//------------------------------------------------------
// module  : FunctionFMFBM.h
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <new>
#include <time.h>
#include <sys/resource.h>

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define PI  3.14159
#define GREY_LEVEL 255
#define BIGNUMBER 100000000
#define TROIS 3
#define NCHAR 200

#define CARRE(X) ((X)*(X))
#define MAX(a,b)   (((a)>(b))?(a):(b))
#define MIN(a,b)   (((a)>(b))?(b):(a))

//------------------------------------------------
// FunctionFMBFM.cc
//------------------------------------------------
//>MatrixAllocation
float*            fmatrix_allocate_1d(int);
float**           fmatrix_allocate_2d(int,int);
float***          fmatrix_allocate_3d(int,int,int);
int*              imatrix_allocate_1d(int);
int**             imatrix_allocate_2d(int,int);
int***            imatrix_allocate_3d(int,int,int);
int****           imatrix_allocate_4d(int,int,int,int);
void  free_fmatrix_1d(float*);
void  free_fmatrix_2d(float**);
void  free_fmatrix_3d(float***,int);
void  free_imatrix_1d(int*);
void  free_imatrix_2d(int**);
void  free_imatrix_3d(int***,int);
void  free_imatrix_3d(int****,int,int);

//>MatrixGestion
void  CopyMat(int**,int**,int,int);
void  CopyMat(int**,float**,int,int);
void  CopyMat(float**,int**,int,int);
void  Recal(float**,int,int); 
void  Recal(int**,int,int);
int   DiffMatNb(int**,int**,int,int);

//>Random
float randomize(void);

//>File
void GetLengthWidth(char*,int*,int*);
void load_image_ppm(char*,int***,int,int);
void SaveImagePgm(char*,char*,float**,int,int);
void SaveImagePgm(char*,char*,int**,int,int);
void SaveImagePgm(char*,char*,unsigned char**,int,int);
void SaveImagePpm(char*,char*,int***,int,int); 
void SaveImagePpm(char*,char*,float***,int,int); 
void SaveTabImagePgm(char*,char*,float***,int,int,int);
void SaveTabImagePgm(char*,char*,int***,int,int,int);

//>SpaceColor
void RGBToHSV(float,float,float,float*,float*,float*);
void RGBToYIQ(float,float,float,float*,float*,float*);
void RGBToXYZ(float,float,float,float*,float*,float*);
void XYZToRGB(float,float,float,float*,float*,float*);
void RGBToLAB(float,float,float,float*,float*,float*);
void RGBToLUV(float,float,float,float*,float*,float*);
void RGBToI1I2I3(float,float,float,float*,float*,float*);
void RGBToH1H2H3(float,float,float,float*,float*,float*);
void RGBToHSL(float,float,float,float*,float*,float*);
void RGBToTSL(float,float,float,float*,float*,float*);
void RGBToYCbCr(float,float,float,float*,float*,float*);
void RGBToP1P2(float,float,float,float*,float*,float*);

//>Kmean
int  Identical(int*,int**,int,int);
void KmeanFast(int**,int,int,int,int*,int,int);
void SegmentationHistoCOLORKmeanFast(int***,int**,int,int,int,int,int,int,int);

//>FusionRegions
void Paint(int**,int**,int,int,int,int,int);
void Paint(float**,float**,int,int,int,int,int);
void ConvertClassRegion(float**,int,int);
int  ComputeNumberRegions(float**,int,int);

//>Clean
int  FuseSmallRegions(int**,int,int,int*,int);
int  FuseSmallRegions(float**,int,int,int*,int,float);
void MedianFilter(float**,int,int,int);

//>VisuContour
void AddContourImg(float**,int***,int,int,int);
void ContourSeg(int**,int**,int,int);
void MoyContourSeg(int***,int,int**,int,int); 

//>GestionSegmentation
void Multires(int***,int,int,int,int***);
void Duplication(float**,float**,int,int,int);
void ConvertClassRegionInf(int**,int**,int,int);

//>Gestion Fusion Model
int   NumberRegionMax(int***,int,int,int);
int   NumberRegionMax(int**,int,int);
int   SelectSegMap(int***,int,int,int,float*,float*);
void  Classify(int***,int,int,int,float*);
void  sort(float**,int,int,int);
void  swap(float*,float*); 

//>MeasureComplexity
float Complexity(int***,int,int,int,int);

//>Distance F-Measure<non-opt>
float DistFMeasure(int**,int**,int,int);
float MoyDistFMeasure(int**,int***,int,int,int,int);

//>Pre-Calcul
void ComputeWeight(float*,float*,int,float);
void ChangeMetaPixel(int**,int**,int**,int,int,int,int);

//>Modele HierarchiqueBloc
void  ICM_FmeasLocHieB4(int**,int**,int***,int,int,int,int,float*,float,float*,int);
