//---------------------------------------------------
// module  : f_FMBFM.cc                       
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include "FMBFM.h"

//------------------------------------------------
// METHODES DE LA CLASSE FMBFM  ------------------
//------------------------------------------------
//----------------------------------------------------------
// Constructeur de la classe FMBFM
//----------------------------------------------------------
FMBFM::FMBFM(int*** imgt,int lgth,int wdth)           
 {
  int i,j,k;

  //Initialisation
  length=lgth;
  width=wdth;

  //Allocation Memoire Matrice 
  mat_img=imatrix_allocate_3d(3,length,width);
  mat_cnt=imatrix_allocate_3d(3,length,width);
  mat_seg=fmatrix_allocate_2d(length,width);

  //Initialisation
  for(k=0;k<3;k++)
  for(i=0;i<length;i++) for(j=0;j<width;j++) 
    { mat_img[k][i][j]=imgt[k][i][j];     
      mat_cnt[k][i][j]=imgt[k][i][j]; }

 //Stack Size Increased (128 MB)
 const rlim_t kStackSize=128*1024*1024;   
 struct rlimit rl;
 int result=getrlimit(RLIMIT_STACK,&rl);
 if (result==0)
 if (rl.rlim_cur<kStackSize)
    {  rl.rlim_cur=kStackSize;
       result=setrlimit(RLIMIT_STACK,&rl);
       if (result!=0) fprintf(stderr,"setrlimit returned result = %d\n",result); } 
 }

//----------------------------------------------------------
// Destructeur de la classe VOIFBM
//----------------------------------------------------------
FMBFM::~FMBFM()
{ 
  //Libere Memoire Matrice 
  if (mat_img)    free_imatrix_3d(mat_img,3);
  if (mat_cnt)    free_imatrix_3d(mat_cnt,3);
  if (mat_seg)    free_fmatrix_2d(mat_seg);
}

//----------------------------//
//----------GESTION-----------//
//----------------------------//
//----------------------------------------------------------
// MultipleSegmentations
// ---------------------
//
//----------------------------------------------------------  
void FMBFM::MultipleSegmentations(int*** TabSeg,int NbSpCl,int NbCl1,int NbCl2,int NbCl3)
{
 int k,l,m;
 int nbreg;

 //Presentation
 printf("\n\n  > MultipleSegmentations [NbSpCol::%d][NbBins::%d][Size::%d]",NbSpCl,NBINS,SIZE1);
 fflush(stdout);

 //-------//
 // Coul  //
 //-------//
   printf("\n  [%d]<NbCl=%d><Coul>",NbSpCl,NbCl1);
   for(k=0,l=0;k<NbSpCl;k++,l++) 
     { SegmentationHistoCOLORKmeanFast(mat_img,TabSeg[k],length,width,NbCl1,NBINS,SIZE1,k,l);
       for(m=0;m<5;m++) if (!FuseSmallRegions(TabSeg[k],length,width,&nbreg,SIZEMIN))  break; } 

   printf("\n  [%d]<NbCl=%d><Coul>",NbSpCl,NbCl2);
   for(k=NbSpCl,l=0;k<(2*NbSpCl);k++,l++) 
     { SegmentationHistoCOLORKmeanFast(mat_img,TabSeg[k],length,width,NbCl2,NBINS,SIZE1,k,l);
       for(m=0;m<5;m++) if (!FuseSmallRegions(TabSeg[k],length,width,&nbreg,SIZEMIN))  break; } 

   printf("\n  [%d]<NbCl=%d><Coul>",NbSpCl,NbCl3);
   for(k=(2*NbSpCl),l=0;k<(3*NbSpCl);k++,l++) 
      { SegmentationHistoCOLORKmeanFast(mat_img,TabSeg[k],length,width,NbCl3,NBINS,SIZE1,k,l);
        for(m=0;m<5;m++) if (!FuseSmallRegions(TabSeg[k],length,width,&nbreg,SIZEMIN))  break; } 


 //-------//
 // NbBin //
 //-------//
   printf("\n  [%d]<NbCl=%d><Nbins-1>",NbSpCl,NbCl1);
   for(k=(3*NbSpCl),l=0;k<(4*NbSpCl);k++,l++) 
     { SegmentationHistoCOLORKmeanFast(mat_img,TabSeg[k],length,width,NbCl1,(NBINS-1),SIZE1,k,l);
       for(m=0;m<5;m++) if (!FuseSmallRegions(TabSeg[k],length,width,&nbreg,SIZEMIN))  break; }  

   printf("\n  [%d]<NbCl=%d><Nbins-1>",NbSpCl,NbCl2);
   for(k=(4*NbSpCl),l=0;k<(5*NbSpCl);k++,l++) 
     { SegmentationHistoCOLORKmeanFast(mat_img,TabSeg[k],length,width,NbCl2,(NBINS-1),SIZE1,k,l);
       for(m=0;m<5;m++) if (!FuseSmallRegions(TabSeg[k],length,width,&nbreg,SIZEMIN))  break; }  
}


//----------------------------------------------------------
// FMeasureFusionModel
//----------------------------------------------------------    
void FMBFM::FMeasureFusionModel()
{
 int k;
 int nbreg;
 float dist;
 char MyBuff[100]; 
 int IndxBestSegFmeas;

 //>Record
 strcpy(MyBuff,Extension);
 
 //>Information
 printf("\n\n FMBFM Algorithm");
 printf("\n -----------------");
 printf("\n Image: [%s] (%d - %d)",Name_Img,length,width);
 printf("\n ---------");
 //printf("\n    > Regularization      >>>  [%.3f]",Regularization);
 fflush(stdout);

 //> Constantes
 int NbSpaceCol=NBSPCOL;
 int NBSEGS=5*NbSpaceCol; 
  
 //>MemoryAllocation
 int****  PopSegInit=imatrix_allocate_4d(2,NBSEGS,length,width);
 float*   TabDist=fmatrix_allocate_1d(NBSEGS);
 float*   TabWght=fmatrix_allocate_1d(NBSEGS);

 float**  Mat1=fmatrix_allocate_2d(length,width);
 int**    MatInt1=imatrix_allocate_2d(length,width);
 int**    MatInt2=imatrix_allocate_2d(length,width);
 int**    MatInt3=imatrix_allocate_2d(length,width);

 
 //===============================================================================
 //> [0] Complexity::NbClasses
 //===============================================================================
  float complexity=Complexity(mat_img,length,width,5,7);
  int NbCl1=(int)(0.5+(NBCL1*complexity));
  int NbCl2=(int)(0.5+(NBCL2*complexity));
  int NbCl3=(int)(0.5+(NBCL3*complexity));
  if (NbCl3<2) NbCl3=2;
  printf(" :: [%f] >> [NbCl1:%d][NbCl2:%d][NbCl3:%d]",complexity,NbCl1,NbCl2,NbCl3);
  fflush(stdout);

 
 //================================================================================
 //> [1] Init. Population :: Multiple ColorSegmentationsRegions [0:class][1:regs]
 //================================================================================ 
 //>MultipleColorSegRegions
 MultipleSegmentations(PopSegInit[0],NbSpaceCol,NbCl1,NbCl2,NbCl3);      
 for(k=0;k<NBSEGS;k++) ConvertClassRegionInf(PopSegInit[0][k],PopSegInit[1][k],length,width);

 //>Classification/Best>MatInt1
 IndxBestSegFmeas=SelectSegMap(PopSegInit[1],length,width,NBSEGS,TabDist,&dist);
 Classify(PopSegInit[1],length,width,NBSEGS,TabDist);
 CopyMat(MatInt1,PopSegInit[1][0],length,width);  

 //DEBUG
 //SaveTabImagePgm("","TabSeg",PopSegInit[1],length,width,NBSEGS);

 //===============================================================================
 //> [2] ICM_FmeasLoc
 //===============================================================================
 ComputeWeight(TabDist,TabWght,NBSEGS,TAU);
 ICM_FmeasLocHieB4(MatInt1,MatInt2,PopSegInit[1],length,width,NBSEGS,NBITERICM,&dist,ALPHA,TabWght,PRECIS);
 
 //DEBUG
 //SaveImagePgm("","SegICM",MatInt2,length,width);

 //===============================================================================
 //> [3] Clean & Visu
 //===============================================================================
 //>Clean
 for(k=0;k<2;k++) if (!FuseSmallRegions(MatInt2,length,width,&nbreg,SIZEMIN/2))  break; 

 //>Clean2
 CopyMat(Mat1,MatInt2,length,width);  
 for(k=0;k<2;k++) if (!FuseSmallRegions(Mat1,length,width,&nbreg,SIZEMIN/2,0.6))  break; 
 CopyMat(MatInt2,Mat1,length,width);

 //>Classe->Regions
 ConvertClassRegionInf(MatInt2,MatInt3,length,width);
 Recal(MatInt3,length,width);

 //>Save
 if (SAVE) SaveImagePgm(Name_Img,(char*)"_Z00",MatInt3,length,width);

 //>Visu
 //AddContourImg(Mat1,mat_cnt,length,width,3);
 CopyMat(mat_seg,MatInt3,length,width);
 //SaveImagePpm(Name_Img,(char*)"_Z00_CONT",mat_cnt,length,width);
 
 //>FreeMemory 
 if (Mat1)     free_fmatrix_2d(Mat1);
 if (MatInt1)  free_imatrix_2d(MatInt1);
 if (MatInt2)  free_imatrix_2d(MatInt2);
 if (MatInt3)  free_imatrix_2d(MatInt3);
 if (TabDist)  free_fmatrix_1d(TabDist); 
 if (TabWght) free_fmatrix_1d(TabWght); 
}


//----------------------------------------------------------
// Test1:: SoftCont
//----------------------------------------------------------    
void FMBFM::Test_SoftCont_FusionModel()
{
 int k,l;
 int nbreg;
 float dist;
 char MyBuff[100]; 
 int IndxBestSegFmeas;
 int NbCl1,NbCl2,NbCl3;
 float alpha;
 int flag_alpha;

 //>Record
 strcpy(MyBuff,Extension);
 
 //>Information
 printf("\n\n FMBFM_SoftContour Algorithm");
 printf("\n -----------------------------");
 printf("\n Image: [%s] (%d - %d)",Name_Img,length,width);
 printf("\n ---------");
 //printf("\n    > Regularization      >>>  [%.3f]",Regularization);
 fflush(stdout);

 //>CONSTANTES
 int NB_FUSIONS=6;
 int NbSpaceCol=NBSPCOL;
 int NBSEGS=5*NbSpaceCol; 
  
 //>MemoryAllocation
 int****  PopSegInit=imatrix_allocate_4d(2,NBSEGS,length,width);
 float*   TabDist=fmatrix_allocate_1d(NBSEGS);
 float*   TabWght=fmatrix_allocate_1d(NBSEGS);

 float**  Mat1=fmatrix_allocate_2d(length,width);
 int**    MatInt1=imatrix_allocate_2d(length,width);
 int**    MatInt2=imatrix_allocate_2d(length,width);
 int**    MatInt3=imatrix_allocate_2d(length,width);
 int**    MatInt4=imatrix_allocate_2d(length,width);
 int**    MatInt5=imatrix_allocate_2d(length,width);
 int***   TabMat=imatrix_allocate_3d(NB_FUSIONS,length,width);

 //>Complexity
 float complexity=Complexity(mat_img,length,width,5,7);
 
 //>Record
 alpha=ALPHA;
 NbCl1=NBCL1;
 NbCl2=NBCL2;
 NbCl3=NBCL3;

 //>CONSTANTES F-MEASURE (Variation classes)
 const int DEL_MIN=-1;
 const int DEL_MAX=4;

 //>CONSTANTES F-MEASURE (Variation alpha)
 const float DEL_ALPHA_MIN=-0.30;
 const float DEL_ALPHA_MAX=0.04;

 
 //===============================================================================
 //> 
 //===============================================================================

 flag_alpha=0;
 for(l=0;l<NB_FUSIONS;l++)
  {
     //>Randomize
     if (!flag_alpha)
     {
      NbCl1=NBCL1+DEL_MIN+(int)((DEL_MAX-DEL_MIN)*randomize());
      NbCl2=NBCL2+DEL_MIN+(int)((DEL_MAX-DEL_MIN)*randomize());
      NbCl3=NBCL3+DEL_MIN+(int)((DEL_MAX-DEL_MIN)*randomize());
      printf("\n  >> <%d>[NbCl1:%d][NbCl2:%d][NbCl3:%d]",l,NbCl1,NbCl2,NbCl3);
      fflush(stdout);
     }
     
     if (flag_alpha)
     {
      alpha=ALPHA+DEL_ALPHA_MIN+((DEL_ALPHA_MAX-DEL_ALPHA_MIN)*randomize());
      printf("\n  >> <%d>[Alpha:%.2f]",l,alpha);
      fflush(stdout);
     }
     
     //>NbClass  
     NbCl1=(int)(0.5+(NbCl1*complexity));
     NbCl2=(int)(0.5+(NbCl2*complexity));
     NbCl3=(int)(0.5+(NbCl3*complexity));

     if (NbCl1<2) NbCl1=2;
     if (NbCl2<2) NbCl2=2;
     if (NbCl3<2) NbCl3=2;
     printf("::[NbCl1:%d][NbCl2:%d][NbCl3:%d]",NbCl1,NbCl2,NbCl3);
     fflush(stdout);
   
     //>MultipleColorSegRegions
     if ((!flag_alpha)||(l==0))
     { MultipleSegmentations(PopSegInit[0],NbSpaceCol,NbCl1,NbCl2,NbCl3);      
       for(k=0;k<NBSEGS;k++) ConvertClassRegionInf(PopSegInit[0][k],PopSegInit[1][k],length,width);
       IndxBestSegFmeas=SelectSegMap(PopSegInit[1],length,width,NBSEGS,TabDist,&dist);
       Classify(PopSegInit[1],length,width,NBSEGS,TabDist);
       CopyMat(MatInt1,PopSegInit[1][0],length,width); } 

     //>ICM
     ComputeWeight(TabDist,TabWght,NBSEGS,TAU);
     ICM_FmeasLocHieB4(MatInt1,MatInt2,PopSegInit[1],length,width,NBSEGS,NBITERICM,&dist,alpha,TabWght,PRECIS);
     for(k=0;k<2;k++) if (!FuseSmallRegions(MatInt2,length,width,&nbreg,SIZEMIN/2))  break; 
     ConvertClassRegionInf(MatInt2,MatInt3,length,width);
     Recal(MatInt3,length,width);
     ContourSeg(MatInt3,MatInt4,length,width);
     CopyMat(TabMat[l],MatInt4,length,width); 

     //>Debug
     //SaveTabImagePgm("","TabCont",TabMat,length,width,NB_FUSIONS);

  }

 //>Final
 MoyContourSeg(TabMat,NB_FUSIONS,MatInt5,length,width);
 SaveImagePgm(Name_Img,(char*)"_CONT",MatInt5,length,width);

 //>Visu
 CopyMat(mat_seg,MatInt5,length,width);
 
 //>FreeMemory 
 if (Mat1)     free_fmatrix_2d(Mat1);
 if (MatInt1)  free_imatrix_2d(MatInt1);
 if (MatInt2)  free_imatrix_2d(MatInt2);
 if (MatInt3)  free_imatrix_2d(MatInt3);
 if (MatInt4)  free_imatrix_2d(MatInt4);
 if (MatInt5)  free_imatrix_2d(MatInt5);
 if (TabDist)  free_fmatrix_1d(TabDist); 
 if (TabWght)  free_fmatrix_1d(TabWght);
 if (TabMat)   free_imatrix_3d(TabMat,NB_FUSIONS);
}
